﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

//a very simple character controller
public class KeyboardInput : MonoBehaviour {
	
	float speed = 2f;
	Dictionary<KeyCode, Vector3> directions; 
	
	// Use this for initialization
	void Start () {
		//initialize all the values in our dictionary
		//here we’re mapping KeyCodes to Vectors
		
		directions = new Dictionary<KeyCode, Vector3>() {
			{KeyCode.W, Vector3.forward}, //move forward
			{KeyCode.S, Vector3.back}, //move backwards
			{KeyCode.A, Vector3.left}, //move left
			{KeyCode.D, Vector3.right}}; //move right
	}

	//a test showing how each GetKey* method operates
	void Update () {

		// if(Input.GetKeyDown(KeyCode.Space)) {
		// 	this.transform.Translate(5f,0f,0f, Space.World);
		// }
		// if(Input.GetKey(KeyCode.Space)) {
		// 	this.transform.Rotate(Vector3.up, 45*Time.deltaTime);
		// }
		// if(Input.GetKeyUp(KeyCode.Space)) {
		// 	this.transform.Translate(-5f,0f,0f, Space.World);
		// }
//
		//Character controller. Parse the keys and move based on input.
		foreach(KeyCode direction in directions.Keys) {
			if(Input.GetKey(direction)) {
				this.transform.Translate(directions[direction] * speed * Time.deltaTime, Space.Self);
			}
		}
	}
}
	